Permutation in String - Leetcode 567 - Fixed Sliding Window (Python)

Поділитися
Вставка
  • Опубліковано 9 січ 2025

КОМЕНТАРІ • 38

  • @GregHogg
    @GregHogg  5 місяців тому +2

    Master Data Structures & Algorithms For FREE at AlgoMap.io!

  • @rocksays80
    @rocksays80 5 місяців тому +28

    This is a more clear explanation than Neetcode. Solidified the concept right away. Thanks!

  • @sanskarshrivastava5193
    @sanskarshrivastava5193 3 місяці тому +2

    way simpler than whole Leet code discussion forum and editorial, you have my respect sir !

  • @Amanda-bg7ib
    @Amanda-bg7ib 5 місяців тому +8

    Better than Neetcode's explanation on the same problem, and more simple/ straightforward too! Came here cuz the neetcode one was too confusing and long

  • @SHIHJUIheh
    @SHIHJUIheh 6 місяців тому +9

    OMG! This is the clearest explanation I have seen! Really hope you keep making videos!

    • @GregHogg
      @GregHogg  6 місяців тому

      Really glad to hear that

  • @tauicsicsics
    @tauicsicsics 4 місяці тому +3

    After watching 3 other videos, this is the clearest of them all, finally understood this problem. Fantastic explanations, pls don't stop making leetcode videos.

  • @vamsikrishnagolla9115
    @vamsikrishnagolla9115 6 днів тому +1

    Wow. This is better explanation I came across.

  • @Alex-tm5hr
    @Alex-tm5hr 5 місяців тому +3

    Another video you explained better than anyone else! Thanks greg!

  • @shantipriya370
    @shantipriya370 2 місяці тому

    just wow.. what a clear and amazing explanation. i was scared of this problem even after looking at various solutions.. your video made it just very simple.. thanks..

  • @ruchikaahujaasm
    @ruchikaahujaasm 5 місяців тому

    Very clear and detailed line by line explanation which helped me to understand the algorithm better. Thank you for your efforts !!!!

  • @ami-does-things
    @ami-does-things 2 місяці тому

    The best explanation I have come across for this problem! thank you so much

  • @RupertBruce
    @RupertBruce 10 місяців тому +2

    The count array gets rid of the permutation problem and the sliding window trick gives a nicely scalable iteration. Edit: watched to the end... Nice

  • @3227998
    @3227998 8 місяців тому +3

    This is an epic explanation! Thank you!

    • @GregHogg
      @GregHogg  8 місяців тому

      Glad to hear it, thanks a ton!!

  • @stuartxu1509
    @stuartxu1509 3 місяці тому

    Thank you so much for making this video! It is crystal clear!

  • @aly7401
    @aly7401 7 місяців тому

    Simple and elegant, thank you for the great video

    • @GregHogg
      @GregHogg  7 місяців тому

      You're very welcome :)

  • @sravangogineni8130
    @sravangogineni8130 2 місяці тому +1

    can we use dict instead of list to store the occurrence of char in the string

  • @Yoshi98able
    @Yoshi98able 8 місяців тому +1

    Really helpful and well explained

    • @GregHogg
      @GregHogg  8 місяців тому

      Glad to hear it, thanks a ton!

  • @yhh4844
    @yhh4844 6 місяців тому

    It's easy to understand, thank you!

  • @yashparekh8914
    @yashparekh8914 3 місяці тому

    Comparing two arrays and checking if they are equal should ideally be O(n1) right? What am I understanding wrong?

    • @deepakumrao4555
      @deepakumrao4555 2 місяці тому +1

      In this case loop only will only runs 26 times since we are comparing arrays that has only 26 values (lower case english alphabets)

  • @ridasohail4318
    @ridasohail4318 9 місяців тому

    Why we build up s2 count array in the first for loop? Why can't we just build it from start in the second loop?

    • @GregHogg
      @GregHogg  8 місяців тому

      It's just easier this way iirc

  • @guruprasadnooliveedu
    @guruprasadnooliveedu 2 місяці тому

    for i in range(abs(len(s2)-len(s1))+1):
    if sorted(s1)==sorted(s2[i:i+len(s1)]):
    return True
    return False
    take alook mr.greg just tried

  • @updownftw
    @updownftw 19 днів тому

    why we not using maps ?

  • @bigk9000
    @bigk9000 3 місяці тому

    Could someone please explain to me why this is faster than the solution I wrote?
    def check_inclusion(s1: str, s2: str) -> bool:
    n1, n2 = len(s1), len(s2)
    if n1 > n2: return False
    permutations = Counter(s1)
    for i in range(n2):
    if permutations == Counter(s2[i:i + n1]):
    return True
    return False

  • @nagarjunachenna7773
    @nagarjunachenna7773 5 місяців тому

    drawing tool name please

  • @sowoul_
    @sowoul_ 10 місяців тому +1

    just do this
    class Solution:
    def checkInclusion(self, s1: str, s2: str) -> bool:
    check = Counter(s1)
    temp = {}
    k=len(s1)
    for i in range(len(s2)):
    if i

  • @philipbrujic4728
    @philipbrujic4728 6 місяців тому

    Good video

  • @cakecup-r6g
    @cakecup-r6g 2 місяці тому

    below is my solution with hasmaps ,can someone please help me the time complexity of my solution i am new to this concept , thanks in advance.
    def string_perms(s1,s2):
    if len(s2) < len(s1):
    return False
    d1={}
    for i in s1:
    d1[i] = d1.get(i,0) + 1
    l=0
    r=len(s1)
    while r

  • @markelmorehome
    @markelmorehome 5 місяців тому

    elegant.

  • @darkemperor9006
    @darkemperor9006 6 місяців тому +1

    confusing solution

  • @user-jm6gp2qc8x
    @user-jm6gp2qc8x 4 місяці тому

    again, why don't you stick to dictionaries lol

  • @moonlight-td8ed
    @moonlight-td8ed 5 місяців тому

    you just got a new sub, thank you